﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Xml;

namespace TicketM
{
    public partial class _Default : Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if (!Page.IsPostBack)
            {
                Models.Tickets ticketing = new Models.Tickets();
                ArrayList projects = ticketing.GetProjects();

                XmlDocument doc = new XmlDocument();
                doc.Load(Server.MapPath(@"\TicketM\App_Data\Projects.xml"));

                foreach (string project in projects)
                {
                    if (doc.DocumentElement.SelectSingleNode("/projects/project[@name='" + project + "']") == null)
                    {
                        this.NonTicketed.Items.Add(project);
                    }
                    else
                    {
                        this.Ticketed.Items.Add(project);
                    }
                }
            }
        }

        protected void Save_Click(object sender, EventArgs e)
        {
            Models.Tickets ticketing = new Models.Tickets();
            if (ticketing.AddTicketWIT2Project(Session["project"].ToString()))
            {
                Save.Enabled = false;
                addButton.Enabled = true;
            }
        }

        protected void addButton_Click(object sender, EventArgs e)
        {
            this.Ticketed.Items.Add(this.NonTicketed.SelectedItem);
            Session.Add("project", this.NonTicketed.SelectedItem.Text);
            this.NonTicketed.Items.Remove(this.NonTicketed.SelectedItem);
            addButton.Enabled = false;
            Save.Enabled = true;
        }
    }
}